## debian-installer 20101020ubuntu72

=== debian/changelog ===
debian-installer (20101020ubuntu72) oneiric; urgency=low

  * No-change rebuild to pick up new components.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 08 Oct 2011 10:43:48 +0100

debian-installer (20101020ubuntu71) oneiric; urgency=low

  * Update help text translations from Launchpad.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 06 Oct 2011 02:07:50 +0100

debian-installer (20101020ubuntu70) oneiric; urgency=low

  [ Colin Watson ]
  * Update help text translations from Launchpad.

  [ Michael Casadevall ]
  * Increase OMAP3/4 netboot image size and compress it

 -- Michael Casadevall <mcasadevall@ubuntu.com>  Tue, 04 Oct 2011 00:59:10 -0700

debian-installer (20101020ubuntu69) oneiric; urgency=low

  * Move armel/omap4 to 3.0.0-1205 kernels.
  * Update help text translations from Launchpad.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 30 Sep 2011 14:15:40 +0100

debian-installer (20101020ubuntu68) oneiric; urgency=low

  * Bump amd64 netboot image size by another 256KiB.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 28 Sep 2011 14:17:45 +0100

debian-installer (20101020ubuntu67) oneiric; urgency=low

  * Re-enable armel/linaro-vexpress and move it to 3.0.0-1007 kernels.
  * Move armel/linaro-omap to 3.0.0-1007 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 28 Sep 2011 10:17:09 +0100

debian-installer (20101020ubuntu66) oneiric; urgency=low

  * Move to 3.0.0-12 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 24 Sep 2011 16:19:45 +0100

debian-installer (20101020ubuntu65) oneiric; urgency=low

  * No-change rebuild to pick up new components.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 20 Sep 2011 01:44:40 +0100

debian-installer (20101020ubuntu64) oneiric; urgency=low

  * Update help text translations from Launchpad.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 19 Sep 2011 16:44:04 +0100

debian-installer (20101020ubuntu63) oneiric; urgency=low

  * Move to 3.0.0-11 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 11 Sep 2011 16:16:50 +0100

debian-installer (20101020ubuntu62) oneiric; urgency=low

  * Move armel/omap4 to 3.0.0-1204 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 06 Sep 2011 14:10:14 +0100

debian-installer (20101020ubuntu61) oneiric; urgency=low

  * Move to 3.0.0-10 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 03 Sep 2011 12:14:55 +0100

debian-installer (20101020ubuntu60) oneiric; urgency=low

  * tell d-i about the new location of MLO for panda netboot images
  * drop build-dependency on omap4 x-loader

 -- Oliver Grawert <ogra@ubuntu.com>  Wed, 31 Aug 2011 00:03:05 +0100

debian-installer (20101020ubuntu59) oneiric; urgency=low

  * No-change rebuild to pick up new kernel.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 26 Aug 2011 16:10:27 +0100

debian-installer (20101020ubuntu58) oneiric; urgency=low

  * Move to 3.0.0-9 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 21 Aug 2011 15:26:14 +0100

debian-installer (20101020ubuntu57) oneiric; urgency=low

  * Move armel/omap4 to 3.0.0-1203 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 20 Aug 2011 10:37:23 +0100

debian-installer (20101020ubuntu56) oneiric; urgency=low

  * Move armel/omap4 to 3.0.0-1202 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 18 Aug 2011 00:40:46 +0100

debian-installer (20101020ubuntu55) oneiric; urgency=low

  * And bump the armel/omap netboot image size by two megabytes too, also to
    account for the addition of WPA support.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 17 Aug 2011 00:47:42 +0100

debian-installer (20101020ubuntu54) oneiric; urgency=low

  * Bump powerpc netboot image size by two megabytes to account for the
    addition of WPA support.
  * Disable armel/linaro-vexpress until LP #826021 is fixed.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Aug 2011 14:04:59 +0100

debian-installer (20101020ubuntu53) oneiric; urgency=low

  * Bump amd64 netboot image size by a megabyte or so; the addition of WPA
    support makes this a bit bigger.
  * Move armel/omap4 to 3.0.0-1201 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 13 Aug 2011 12:18:32 +0100

debian-installer (20101020ubuntu52) oneiric; urgency=low

  * No-change rebuild to pick up new components.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 12 Aug 2011 15:33:14 +0100

debian-installer (20101020ubuntu51) oneiric; urgency=low

  * Move to 3.0.0-8 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 08 Aug 2011 11:42:59 +0100

debian-installer (20101020ubuntu50) oneiric; urgency=low

  * Move armel/omap4 to 3.0.0-1200 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 29 Jul 2011 09:47:25 +0100

debian-installer (20101020ubuntu49) oneiric; urgency=low

  * No-change rebuild to pick up new components.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 26 Jul 2011 09:03:49 +0100

debian-installer (20101020ubuntu48) oneiric; urgency=low

  * Move to 3.0.0-7 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 24 Jul 2011 17:43:03 +0100

debian-installer (20101020ubuntu47) oneiric; urgency=low

  * Move to 3.0.0-6 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 24 Jul 2011 10:15:58 +0100

debian-installer (20101020ubuntu46) oneiric; urgency=low

  [ Brian Murray ]
  * Update minimum disk space requirements for installing Ubuntu.  Thanks to
    Matheus de Araújo for the patch.  (LP: #758942) 

  [ Emmet Hikory ]
  * Publish MLO and u-boot.bin for omap netboot targets (LP: #808810)

  [ Colin Watson ]
  * Move to 3.0.0-5 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 13 Jul 2011 10:58:22 +0100

debian-installer (20101020ubuntu45) oneiric; urgency=low

  * Move to 3.0.0-4 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Sat, 09 Jul 2011 22:12:25 +0100

debian-installer (20101020ubuntu44) oneiric; urgency=low

  * No-change rebuild to pick up new omap4 kernels for netboot images. 

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 06 Jul 2011 16:10:14 -0600

debian-installer (20101020ubuntu43) oneiric; urgency=low



=== debian/control ===
Source: debian-installer
Section: devel
Priority: optional
Maintainer: Ubuntu Installer Team <ubuntu-installer@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
Uploaders: Frans Pop <fjp@debian.org>, Otavio Salvador <otavio@debian.org>
Standards-Version: 3.8.3
XS-Debian-Vcs-Svn: svn://svn.debian.org/d-i/trunk/installer
Vcs-Bzr: http://bazaar.launchpad.net/~ubuntu-core-dev/debian-installer/ubuntu
Build-Conflicts: libnewt-pic [mipsel]
# NOTE: Do not edit the next line by hand. See comment below.
Build-Depends: debhelper (>= 7.0.0), apt, apt-utils, gnupg, ubuntu-keyring, dctrl-tools, wget, bc, debiandoc-sgml, xsltproc, docbook-xml, docbook-xsl, libbogl-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], lsb-release, glibc-pic, libslang2-pic (>= 2.0.6-4), libnewt-pic (>= 0.52.2-11.3) [!mipsel], libnewt-dev (>= 0.52.2-11.3) [mipsel], libgcc1 [i386 amd64], cramfsprogs [powerpc ia64 mips mipsel armeb armel], genext2fs (>= 1.3-7.1), e2fsprogs, mklibs (>= 0.1.25), genisoimage (>= 9:1.1.10-1ubuntu2) [!s390 !s390x], genromfs [sparc sparc64], hfsutils [powerpc], dosfstools (>= 3.0.9-1ubuntu2) [i386 ia64 m68k amd64 armel], cpio, devio [armeb armel], parted [armel], slugimage (>= 0.10+r58-6) [armeb armel], u-boot-tools [armel], syslinux (>= 2:4.02) [i386 amd64], palo [hppa], elilo [ia64], yaboot [powerpc], aboot (>= 0.9b-2) [alpha], silo [sparc], sparc-utils [sparc sparc64], genisovh [mips], tip22 [mips], colo [mipsel], sibyl [mips mipsel], atari-bootstrap [m68k], vmelilo [m68k], m68k-vme-tftplilo [m68k], amiboot [m68k], emile [m68k], emile-bootblocks [m68k], x-loader-omap3-beagle [armel], u-boot-linaro-omap3-beagle [armel], u-boot-linaro-omap4-panda [armel], tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64], mtools [i386 ia64 m68k amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 armel], po4a [i386 amd64], python [i386 amd64], module-init-tools [i386 armeb armel amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sh4 sparc sparc64], bf-utf-source [!s390 !s390x], mkvmlinuz [powerpc], openssl [armel], makefs [kfreebsd-i386 kfreebsd-amd64], grub-pc (>= 1.98~20100101-1) [kfreebsd-i386 kfreebsd-amd64 hurd-i386], xorriso [kfreebsd-i386 kfreebsd-amd64 hurd-i386], grub-efi-amd64-bin [amd64], grub-common [amd64], debian-ports-archive-keyring [sh4 sparc64]
# This package has the worst Build-Depends in Debian, so it deserves some
# explanation. Note that this comment can also be used to generate a
# Build-Depends line, by running the debian/genbuilddeps program.
# So put each build dep on its own line, prefixed by " - " and to
# comment out a build dep, start the line with two hashes. And don't edit
# the Build-Depends line above by hand.
#
# Base build dependencies:
#	- debhelper (>= 7.0.0)
#		Of course.
# 	- apt
# 		Used for downloading udebs.
# 	- apt-utils
# 		apt-ftparchive is used for including localudebs.
#	- gnupg
#		New versions of apt need gnupg for security checks.
#	- ubuntu-keyring
#		To provide the archive key for security checks.
#	- dctrl-tools
#		Various manipulations of the udeb Packages files.
#	- wget
#		Used to test validity of mirrors.
#	- bc
#		Used for some image size calculations.
#	- debiandoc-sgml
#		partman's manual is in debiandoc.
#	- xsltproc
#	- docbook-xml
#	- docbook-xsl
#		The d-i internals manual is in DocBook XML.
#	- libbogl-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386]
#		For bdftobogl used in font reduction.
#	- lsb-release
#		Provides system version information.
#	
# Library build dependencies:
#	- glibc-pic
#		For library reduction.
#	- libslang2-pic (>= 2.0.6-4)
#		Make dependency versioned temporarily to make sure we avoid #392942
#	- libnewt-pic (>= 0.52.2-11.3) [!mipsel]
#		Rather than use slang and newt udebs, reduced versions of
#		the libraries are put onto images to save space.
#	- libnewt-dev (>= 0.52.2-11.3) [mipsel]
#		On mipsel, we can't use libnewt-pic right now due to bug
#		#329733. See also Build-Conflicts above.
#	- libgcc1 [i386 amd64]
#		On x86 we need to include /lib/libgcc_s.so.1 in g-i initrds to
#		work around #373253 until upstream can remove pthread_cancel()
#		On i386 
#		calls in directfb. For now, this is done by setting EXTRAFILES.
#
# Filesystem tools:
#	- cramfsprogs [powerpc ia64 mips mipsel armeb armel]
#		For arches that use cramfs initrds.
#	- genext2fs (>= 1.3-7.1)
#		For creating ext2 filesystems without being root.
#		1.3-7.1 fixes issues on several arches.
#	- e2fsprogs
#		genext2fs doesn't produce perfect filesystems, so we fsck
#		them.
#		Lintian: Yes, we know it's essential. We prefer not to
#		count on it remaining so.
#	- mklibs (>= 0.1.25)
#		We use mklibs for library reduction.
#	- genisoimage (>= 9:1.1.10-1ubuntu2) [!s390 !s390x]
#		For making mini isos.
#	- genromfs [sparc sparc64]
#		Used for creating sparc floppies (which are not built by
#		default.)
#	- hfsutils [powerpc]
#		For making bootable HFS USB sticks for powerpc.
#	- dosfstools (>= 3.0.9-1ubuntu2) [i386 ia64 m68k amd64 armel]
#		For creating FAT filesystems with mkfs.msdos.
#		Of course i386/amd64 use this for floppies, CDs etc.
#		ia64 uses it for floppies (?)
#		m68k uses it for atari floppies
#		armel uses it for omap3/4 netboot images and requires
#		3.0.9-1ubuntu2 to create bootable filesystems on OMAP
#	- cpio
#		For creating initramfs images.
#	- devio [armeb armel]
#		Tool to read and write from block devices, used to byteswap
#		kernels and add nslu2 boot magic.
#	- parted [armel]
#		For ARM OMAP images.
#	- slugimage (>= 0.10+r58-6) [armeb armel]
#		For building nslu2 firmware images.
#	- u-boot-tools [armel]
#		For creating u-boot images
#
# Boot loaders:
#	On many arches boot loaders are copied onto or ran on the boot
#	images in one way or another. There's a reason our mailing list is
#	still called debian-boot..
#	- syslinux (>= 2:4.02) [i386 amd64]
#		With isohybrid.
#	- palo [hppa]
#	- elilo [ia64]
#	- yaboot [powerpc]
#		For all our powerpc boot needs. Well, not really.
#	- aboot (>= 0.9b-2) [alpha]
#		A previous version didn't have netabootwrap.
#	- silo [sparc]
#		Using silo is problimatic since it needs to run as root,
#		so images that need it are not built by default, but we
#		include it for completeness.
#	- sparc-utils [sparc sparc64]
#		For elftoaout and piggyback, to make netboot images.
#	- genisovh [mips]
#		Makes mini iso images bootable on SGI MIPSen.
#	- tip22 [mips]
#		Piggyback netboot images.
#	- colo [mipsel]
#		For booting Cobalt machines.
#	- sibyl [mips mipsel]
# 		For booting the SWARM board.
#	- atari-bootstrap [m68k]
#		Booting and other tools for Atari systems.
#	- vmelilo [m68k]
#	- m68k-vme-tftplilo [m68k]
#		For VME machines, although it doesn't yet support running
#		as non-root, the install will try to use it and fall back
#		to a warning when it fails.
#	- amiboot [m68k]
#		Bootloader for m68k/amiga machines.
#	- emile [m68k]
#	- emile-bootblocks [m68k]
#		Bootloader for m68k/mac machines.
#	- x-loader-omap3-beagle [armel]
#	- u-boot-linaro-omap3-beagle [armel]
#	- u-boot-linaro-omap4-panda [armel]
#		First and second state bootloaders for omap 3/4
#
# Architecture specific build dependencies:
#	- tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64]
#		For todos, used on files that need to be accessible from
#		DOS.
#	- mtools [i386 ia64 m68k amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 armel]
#		mcopy is used to put files onto FAT filesystems w/o
#		mounting them.
#	- po4a [i386 amd64]
#	- python [i386 amd64]
#		For building gfxboot help texts.
#
#	- module-init-tools [i386 armeb armel amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sh4 sparc sparc64]
#		depmod for 2.6 kernels on the arches that support 2.6.
#
#	- bf-utf-source [!s390 !s390x]
#		Contains the unicode font we use. Not a udeb since we
#		perform font reduction at build time.
#	- mkvmlinuz [powerpc]
#		Used to make powerpc images that can boot direct from
#		firmware w/o using a boot loader.
#	- openssl [armel]
#		Used to encrypt a firmware image so an ARM based device
#		(Thecus N2100) will accept it.
#	- makefs [kfreebsd-i386 kfreebsd-amd64]
#		Used to create an UFS1 filesystem from a directory tree.
#	- grub-pc (>= 1.98~20100101-1) [kfreebsd-i386 kfreebsd-amd64 hurd-i386]
#		Used as the CD-ROM's bootloader
#       - xorriso [kfreebsd-i386 kfreebsd-amd64 hurd-i386]
#               Used by grub-pc to create the CD-ROM images
#	- grub-efi-amd64-bin [amd64]
#		EFI bootloader support.
#	- grub-common [amd64]
#		For the GRUB font.
#	- debian-ports-archive-keyring [sh4 sparc64]
#		Used for architectures hosted on debian-ports.org

Package: debian-installer
Architecture: any
Description: Debian installer
 This package currently only contains some documentation for the Debian
 installer. We welcome suggestions about what else to put in it.

=== debian/rules ===
#! /usr/bin/make -f

ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
VERSION=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Version: | cut -d ' ' -f 2)
DATE=$(shell echo $(VERSION) | cut -d '.' -f 1)
SUITE=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Distribution: | cut -d ' ' -f 2 | cut -d - -f 1)
ifeq (${SUITE},UNRELEASED)
USE_UDEBS_FROM=oneiric
TRANSSTATUS=
BOOTMENU_BEEP=n
else
USE_UDEBS_FROM=$(SUITE)
USE_PROPOSED_UPDATES=0
TRANSSTATUS=translation-status
BOOTMENU_BEEP=y
endif

ARCHIVEDIR=debian/tmp/installer-$(ARCH)
DESTDIR=$(ARCHIVEDIR)/$(VERSION)
IMAGEDIR=$(DESTDIR)/images
TARNAME=debian-installer-images_$(VERSION)_$(ARCH).tar.gz

clean:
	dh_testdir
	dh_testroot
	dh_clean
	$(MAKE) -C build reallyclean
	$(MAKE) -C doc/devel/partman clean
	$(MAKE) -C doc/devel/internals clean

# Must run as root, so is not run as part of regular build.
build-images:
	$(MAKE) -C build all_build stats release \
		USE_UDEBS_FROM=$(USE_UDEBS_FROM) BUILD_DATE=$(DATE) \
		USE_PROPOSED_UPDATES=$(USE_PROPOSED_UPDATES) \
		TRANSSTATUS=$(TRANSSTATUS) BOOTMENU_BEEP=$(BOOTMENU_BEEP)
	
build: build-stamp
build-stamp:
	rm -f $@
	$(MAKE) -C doc/devel/internals
	$(MAKE) -C doc/devel/partman
	touch $@

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	
	debian/rules build-images

	install -d $(IMAGEDIR)
	cp -a build/dest/* $(IMAGEDIR)
	ln -s $(VERSION) $(ARCHIVEDIR)/current

binary-arch: install  
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs doc/* -X Makefile -X build.sh -X .xsl \
		-X internals.xml -X partman-doc.sgml
	dh_compress
	dh_fixperms
	dh_gencontrol
	dh_md5sums
	dh_builddeb
	cd debian/tmp && tar czvf ../../../$(TARNAME) .
	dpkg-distaddfile $(TARNAME) raw-installer -

binary-indep:

binary: binary-indep binary-arch 
.PHONY: build build-images clean binary-indep binary-arch binary install

## debian-installer 20101020ubuntu72.1

=== build/Makefile ===
#!/usr/bin/make -f
#
# Debian Installer system makefile.
# Copyright 2001-2003 by Joey Hess <joeyh@debian.org> and the d-i team.
# Licensed under the terms of the GPL.
#
# This makefile builds a debian-installer system and bootable images from 
# a collection of udebs which it downloads from a Debian archive. See
# README for details.
#
#
# General layout of our build directory hierarchy
#
# build/config/[<subarch>/][<medium>/][<flavour>/]<leaf-config>
# build/tmp/[<subarch>/][<medium>/][<flavour>/]<build-area>
# build/dest/[<subarch>/][<medium>/][<flavour>-]<images>
#
# Items in brackets can be left out if they are superfluous.
#
# These following <image> names are conventional.
#
# For small changeable media (floppies and the like):
# - boot.img, root.img, driver.img
#
# For single bootable images (e.g. tftp boot images):
# - boot.img
#
# For compressed single bootable images (harddisk or hd emulation):
# - boot.img.gz
#
# If those are not bootable:
# - root.img.gz
#
# Raw kernel images:
# - vmlinux or vmlinuz
#
# Example:
#
# dest/
# |-- cdrom-boot.img
# |-- floppy
# |   |-- access
# |   |   |-- boot.img
# |   |   |-- drivers.img
# |   |   `-- root.img
# |   |-- boot.img
# |   |-- cd-drivers.img
# |   |-- net-drivers.img
# |   `-- root.img
# |-- hd-media-boot.img.gz
# `-- netboot
#     |-- initrd.gz
#     `-- vmlinuz
#

# Add to PATH so dpkg will always work, and so local programs will be found.
PATH := util:$(PATH):/usr/sbin:/sbin

# We don't want this to be run each time we re-enter.
ifndef DEB_HOST_ARCH
DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS = $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_CPU = $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_SYSTEM = $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)
DEB_HOST_MULTIARCH = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_ARCH DEB_HOST_ARCH_OS DEB_HOST_GNU_CPU DEB_HOST_GNU_SYSTEM DEB_HOST_MULTIARCH
endif

# We loop over all needed combinations of ARCH, SUBARCH, MEDIUM, FLAVOUR
# via recursive make calls. ARCH is constant, we don't support
# crosscompiling.
ARCH = $(DEB_HOST_ARCH)

# By default, we just advertise what we can do.
.PHONY: all
all: list

# Globally useful variables.
targetstring = $(patsubst _%,%,$(if $(SUBARCH),_$(SUBARCH),)$(if $(MEDIUM),_$(MEDIUM),)$(if $(FLAVOUR),_$(FLAVOUR),))
targetdirs = $(subst _,/,$(targetstring))

# Overridden in config/hurd.cfg
define genext2fs
  genext2fs -d $(TREE) -b `expr $$(du -s $(TREE) | cut -f 1) + $$(expr $$(find $(TREE) | wc -l) \* 2)` -m 0
endef

# Configurations for the varying ARCH, SUBARCH, MEDIUM, FLAVOUR.
# For simplicity, we use a similiar tree layout for config/, tmp/
# and dest/.
#
# Cheap trick: if one of the variables isn't defined, we run in
# a non-existing file and ignore it.
include config/common
include config/dir
-include config/$(ARCH).cfg
-include config/$(ARCH)/$(SUBARCH).cfg
-include config/$(ARCH)/$(SUBARCH)/$(MEDIUM).cfg
-include config/$(ARCH)/$(SUBARCH)/$(MEDIUM)/$(FLAVOUR).cfg
-include config/local

export KEYRING
export KERNELVERSION
export LOCALUDEBDIR

ifneq ($(shell id -u),0)
  ROOTCMD ?= fakeroot
endif

# Useful command sequences
define submake
  $(ROOTCMD) $(MAKE) --no-print-directory
endef

define recurse_once
  @set -e; $(submake) $(1)_$(2)
endef

define recurse_many
  @set -e; $(foreach var,$($(1)_SUPPORTED) $(if $(RECURSE_EXTRA),$($(1)_SUPPORTED_EXTRA)),$(submake) $(2)_$(3) $(1)=$(var);)
endef

define recurse
  $(if $($(1)_SUPPORTED)$(if $(RECURSE_EXTRA),$($(1)_SUPPORTED_EXTRA)),$(call recurse_many,$(1),$(2),$(3)),$(call recurse_once,$(2),$(3)))
endef

define mkinitramfs
  (cd $(TREE) && find . | cpio --quiet -o -H newc) > 
endef

define mkfs.ufs1
  sh -c 'makefs -t ffs -s 42m -f 3000 -o minfree=0,version=1 $$0 ${TREE}'
endef

define e2fsck
  e2fsck -fy
endef

define mkcramfs
  mkcramfs -z $(TREE)
endef

# Define MKFS_JFFS2 in the config file for your target.
# For example: MKFS_JFFS2 = mkfs.jffs2 -f -p -b -e 0x20000
define mkjffs2
  $(MKFS_JFFS2) -d $(TREE) -o
endef

# A generic recursion rule
.PHONY: all_%
all_%:
	@install -d $(STAMPS)
	$(call recurse,SUBARCH,subarch,$*)

.PHONY: subarch_%
subarch_%:
	$(call recurse,MEDIUM,medium,$*)

.PHONY: medium_%
medium_%:
	$(call recurse,FLAVOUR,flavour,$*)

.PHONY: flavour_%
flavour_%:
	$(if $(targetstring),@$(submake) _$*)

# Validate a targetstring, echo env variables for valid ones
.PHONY: validate_%
validate_%:
	@set -e; \
	SUBARCH= var='$(subst _, ,$(subst validate_,,$@))'; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(SUBARCH_SUPPORTED)$(SUBARCH_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(SUBARCH_SUPPORTED) $(SUBARCH_SUPPORTED_EXTRA) |grep -w $$tmp)" ] || SUBARCH=$$tmp; \
	$(submake) medium_validate SUBARCH=$$SUBARCH var="$$var"

.PHONY: medium_validate
medium_validate:
	@set -e; \
	MEDIUM= var="$(strip $(patsubst $(SUBARCH)%,%,$(var)))"; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(MEDIUM_SUPPORTED)$(MEDIUM_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(MEDIUM_SUPPORTED) $(MEDIUM_SUPPORTED_EXTRA) |grep -w $$tmp)" ] || MEDIUM=$$tmp; \
	$(submake) flavour_validate MEDIUM=$$MEDIUM var="$$var"

.PHONY: flavour_validate
flavour_validate:
	@set -e; \
	FLAVOUR= var="$(strip $(patsubst $(MEDIUM)%,%,$(var)))"; \
	tmp=$$(echo $$var |sed 's/[ ].*$$//'); \
	[ -z '$(FLAVOUR_SUPPORTED)$(FLAVOUR_SUPPORTED_EXTRA)' ] || [ -z "$$tmp" ] || [ -z "$$(echo $(FLAVOUR_SUPPORTED) $(FLAVOUR_SUPPORTED_EXTRA) | grep -w $$tmp)" ] || FLAVOUR=$$tmp; \
	$(submake) finish_validate FLAVOUR=$$FLAVOUR var="$$var"

.PHONY: finish_validate
finish_validate:
	@set -e; \
	var="$(strip $(patsubst $(FLAVOUR)%,%,$(var)))"; \
	if [ -z "$$var" ]; then \
		echo SUBARCH=$$SUBARCH MEDIUM=$$MEDIUM FLAVOUR=$$FLAVOUR; \
	else \
		echo SUBARCH= MEDIUM= FLAVOUR=; \
	fi;


# List all targets useful for direct invocation.
.PHONY: list
list:
	@echo "Useful targets:"
	@echo
	@echo "list"
	@echo "all_build"
	@echo "all_rebuild"
	@echo "stats"
	@echo "all_clean"
	@echo "reallyclean"
	@echo
	@$(submake) all_list RECURSE_EXTRA=1

.PHONY: _list
_list:
	@set -e; \
	echo build_$(targetstring); \
	echo stats_$(targetstring); \
	$(if $(findstring $(MEDIUM),$(WRITE_MEDIA)),echo write_$(targetstring);) \
	echo clean_$(targetstring); \
	echo rebuild_$(targetstring); \
	echo demo_$(targetstring); \
	echo shell_$(targetstring); \
	echo uml_$(targetstring); \
	echo qemu_$(targetstring); \
	echo


# Clean all targets.
.PHONY: reallyclean
reallyclean: all_clean
	rm -rf $(APTDIR) $(APTDIR).udeb $(APTDIR).deb $(BASE_DEST) $(BASE_TMP) $(SOURCEDIR) $(DEBUGUDEBDIR)
	rm -f sources.list sources.list.udeb $(LOCALUDEBDIR)/Packages.gz $(LOCALUDEBDIR)/Packages
	rm -rf $(UDEBDIR) $(STAMPS)

# For manual invocation, we provide a generic clean rule.
.PHONY: clean_%
clean_%:
	@$(submake) _clean $(shell $(submake) $(subst clean_,validate_,$@))
	update-manifest

# The general clean rule.
.PHONY: _clean
_clean: tree_umount
	@[ -n "$(SUBARCH) $(MEDIUM) $(FLAVOUR)" ] || { echo "invalid target"; false; }
	-rm -f $(STAMPS)tree-unpack-$(targetstring)-stamp $(STAMPS)tree-$(targetstring)-stamp $(STAMPS)extra-$(targetstring)-stamp $(STAMPS)get_udebs-$(targetstring)-stamp
	rm -f $(TEMP)/diskusage.txt
	rm -f $(TEMP)/all.utf
	rm -f $(TEMP)/unifont.bdf $(TREE)/lib/unifont.bgf
	rm -f pkg-lists/standard-udebs pkg-lists/kernel-module-udebs
	rm -rf $(TARGET)
	rm -rf $(TEMP)

# all_build is provided automagically, but for manual invocation
# we provide a generic build rule.
.PHONY: build_%
build_%:
	@install -d $(STAMPS)
	@$(submake) _build $(shell $(submake) $(subst build_,validate_,$@))

# The general build rule.
.PHONY: _build
_build:
	@[ -n "$(SUBARCH) $(MEDIUM) $(FLAVOUR)" ] || { echo "invalid target"; false; }
	@$(submake) tree_umount $(EXTRATARGETS) $(TARGET)

# Convenience rules to clean and build.
.PHONY: rebuild_%
rebuild_%:
	@$(submake) clean_$(subst rebuild_,,$@) build_$(subst rebuild_,,$@)

.PHONY: _rebuild
_rebuild:
	@$(submake) _clean _build

# Run before releasing built files.
release:
	egrep '^[[:space:]]' $(BASE_DEST)/MANIFEST.udebs | \
		sed 's/^[[:space:]]*//' | sort | uniq > $(BASE_DEST)/udeb.list
	rm -f $(BASE_DEST)/MD5SUMS $(BASE_DEST)/SHA1SUMS $(BASE_DEST)/SHA256SUMS
	cd $(BASE_DEST) && md5sum `find . -type f` > MD5SUMS
	cd $(BASE_DEST) && sha1sum `find . -type f` > SHA1SUMS
	cd $(BASE_DEST) && sha256sum `find . -type f` > SHA256SUMS

# The general tree target.
$(STAMPS)tree-unpack-$(targetstring)-stamp: $(STAMPS)get_udebs-$(targetstring)-stamp
	dh_testroot
	@[ -d ../debian ] || { echo "directory '../debian' not found; complete source of 'debian-installer' package is required"; false; }
	cd .. && dpkg-checkbuilddeps
	@rm -f $@

	# This build cannot be restarted, because dpkg gets confused.
	rm -rf $(TREE)
	# Set up the basic files [u]dpkg needs.
	mkdir -p $(DPKGDIR)/info
	ln -nsf . $(DPKGDIR)/info/$(shell dpkg --print-architecture)
	touch $(DPKGDIR)/status
	# Create a tmp tree
	mkdir -p $(TREE)/tmp
	# Only dpkg needs this stuff, so it can be removed later.
	mkdir -p $(DPKGDIR)/updates/
	touch $(DPKGDIR)/available

ifdef TRANSSTATUS
	# Include translation status file; warn if older than 2 weeks.
	# Do this first to make possible warnings more visible.
	@echo; \
	if [ -f "$(TRANSSTATUS)" ]; then \
		olddate=$$(grep "^# Generated on:" $(TRANSSTATUS) | sed "s/.*: //"); \
		if [ "$$olddate" ]; then \
			if [ $$(( $$(date -u "+%s") - \
			          $$(date -d "$$olddate" "+%s") \
			       )) -gt 1209600 ]; then \
				echo "WARNING: The data in '$(TRANSSTATUS)' is older than 2 weeks."; \
				echo "         Should it maybe be updated?"; \
				sleep 15; \
			fi; \
		else \
			echo "WARNING: no timestamp found in $(TRANSSTATUS)."; \
			sleep 15; \
		fi; \
		mkdir -p $(TREE)/usr/share/localechooser; \
		cp $(TRANSSTATUS) $(TREE)/usr/share/localechooser/translation-status; \
	else \
		echo "WARNING: the file $(TRANSSTATUS) does not exist."; \
		sleep 5; \
	fi
endif

	# Unpack the udebs with dpkg. This command must run as root
	# or fakeroot.
	echo -n > $(TEMP)/diskusage.txt
	set -e; \
	oldsize=0; oldblocks=0; oldcount=0; for udeb in $(UDEBDIR)/*.udeb ; do \
		if [ -f "$$udeb" ]; then \
			pkg=`basename $$udeb` ; \
			dpkg $(DPKG_UNPACK_OPTIONS) --log=/dev/null --root=$(TREE) --unpack $$udeb ; \
			newsize=`du -bs $(TREE) | awk '{print $$1}'` ; \
			newblocks=`du -s $(TREE) | awk '{print $$1}'` ; \
			newcount=`find $(TREE) -type f | wc -l | awk '{print $$1}'` ; \
			usedsize=`echo $$newsize - $$oldsize | bc`; \
			usedblocks=`echo $$newblocks - $$oldblocks | bc`; \
			usedcount=`echo $$newcount - $$oldcount | bc`; \
			version=`dpkg-deb --info $$udeb | grep '^ *Version:' | sed 's/^ *//' | awk '{print $$2}'` ; \
			echo " $$usedsize B - $$usedblocks blocks - $$usedcount files from $$pkg (version $$version)" >>$(TEMP)/diskusage.txt;\
			oldsize=$$newsize ; \
			oldblocks=$$newblocks ; \
			oldcount=$$newcount ; \
		fi; \
	done
	sort -n < $(TEMP)/diskusage.txt > $(TEMP)/diskusage.txt.new && \
		mv $(TEMP)/diskusage.txt.new $(TEMP)/diskusage.txt
	grep-dctrl -nsPackage,Version,Architecture '' $(TREE)/var/lib/dpkg/status | \
		perl -nle '$$p = $$_; $$v = <>; chomp $$v; $$a = <>; chomp $$a; <>; print "$$p $$v $$a"' | \
		sort > $(TEMP_UDEB_LIST)

	# Clean up after dpkg.
	rm -rf $(DPKGDIR)/updates
	rm -f $(DPKGDIR)/available $(DPKGDIR)/*-old $(DPKGDIR)/lock

ifdef EXTRAFILES
	# Copy in any extra files.
	set -e; \
	for file in $(EXTRAFILES); do \
		mkdir -p $(TREE)/`dirname $$file`; \
		cp -a $$file $(TREE)/$$file; \
	done
endif

ifeq ($(DEB_HOST_ARCH_OS),linux)
ifdef KERNELVERSION
	# Set up modules.dep, ensure there is at least one standard dir (kernel
	# in this case), so depmod will use its prune list for archs with no
	# modules.
	set -e; \
	$(foreach VERSION,$(KERNELVERSION), \
		sysmap_name=; sysmap_opt=; \
		if [ -n "$(VERSIONED_SYSTEM_MAP)" ]; then \
			[ ! -e $(TREE)/boot/System.map-$(VERSION) ] || sysmap_name="$(TREE)/boot/System.map-$(VERSION)"; \
		else \

=== debian/changelog ===
debian-installer (20101020ubuntu72.1) oneiric-proposed; urgency=low

  * Use udebs from oneiric-security, oneiric-proposed, and oneiric-updates.
  * Move to 3.0.0-22 kernels.
  * Move armel/omap4 to 3.0.0-1212 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 04 Jul 2012 10:23:27 +0100

## debian-installer 20101020ubuntu136

=== build/Makefile ===
--- 
+++ 
@@ -280,9 +280,9 @@
 	egrep '^[[:space:]]' $(BASE_DEST)/MANIFEST.udebs | \
 		sed 's/^[[:space:]]*//' | sort | uniq > $(BASE_DEST)/udeb.list
 	rm -f $(BASE_DEST)/MD5SUMS $(BASE_DEST)/SHA1SUMS $(BASE_DEST)/SHA256SUMS
-	cd $(BASE_DEST) && md5sum `find . -type f` > MD5SUMS
-	cd $(BASE_DEST) && sha1sum `find . -type f` > SHA1SUMS
-	cd $(BASE_DEST) && sha256sum `find . -type f` > SHA256SUMS
+	cd $(BASE_DEST) && md5sum `find . -type f ! -name \*SUMS` > MD5SUMS
+	cd $(BASE_DEST) && sha1sum `find . -type f ! -name \*SUMS` > SHA1SUMS
+	cd $(BASE_DEST) && sha256sum `find . -type f ! -name \*SUMS` > SHA256SUMS
 
 # The general tree target.
 $(STAMPS)tree-unpack-$(targetstring)-stamp: $(STAMPS)get_udebs-$(targetstring)-stamp
@@ -378,5 +378,3 @@
 	$(foreach VERSION,$(KERNELVERSION), \
 		sysmap_name=; sysmap_opt=; \
 		if [ -n "$(VERSIONED_SYSTEM_MAP)" ]; then \
-			[ ! -e $(TREE)/boot/System.map-$(VERSION) ] || sysmap_name="$(TREE)/boot/System.map-$(VERSION)"; \
-		else \

=== debian/changelog ===
debian-installer (20101020ubuntu136) precise; urgency=low

  * No-change rebuild to pick up new cdrom-checker.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 23 Apr 2012 11:49:02 -0700

debian-installer (20101020ubuntu135) precise; urgency=low

  * Update help text translations from Launchpad.
  * Add all characters in /usr/share/console-setup-mini/kbdnames.gz to the
    reduced font (LP: #985614).

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 19 Apr 2012 18:35:20 +0100

debian-installer (20101020ubuntu134) precise; urgency=low

  * Call mklibs with a hardcoded --ldlib in armhf.cfg, so we get a
    deterministic result in our linker search, and then add the
    symlink from the old linker path in build/Makefile (LP: #984007)
  * Rebuild with latest omap4 kernels for ext2 support (LP: #984180)

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 17 Apr 2012 23:20:29 -0600

debian-installer (20101020ubuntu133) precise; urgency=low

  * Move armel/omap4 and armhf/omap4 to 3.2.0-1412.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 13 Apr 2012 07:11:30 -0600

debian-installer (20101020ubuntu132) precise; urgency=low

  * Add a new hd-media/non-pae build for i386 (LP: #977568).

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 12 Apr 2012 00:36:26 +0100

debian-installer (20101020ubuntu131) precise; urgency=low

  * Update help text translations from Launchpad.
  * Move to 3.2.0-23 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 11 Apr 2012 11:19:26 +0100

debian-installer (20101020ubuntu130) precise; urgency=low

  * Move armhf/armadaxp to 3.2.0-1602 kernels.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 05 Apr 2012 15:26:26 -0600

debian-installer (20101020ubuntu129) precise; urgency=low

  * nic-firmware grew by nearly 4MB (!).  Bump amd64, i386, and powerpc
    netboot image sizes to match.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 04 Apr 2012 17:10:37 +0100

debian-installer (20101020ubuntu128) precise; urgency=low

  * Move to 3.2.0-22 kernels.
  * Move armhf/armadaxp to 3.2.0-1601 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 04 Apr 2012 13:07:57 +0100

debian-installer (20101020ubuntu127) precise; urgency=low

  * Move to 3.2.0-21 kernels.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 30 Mar 2012 15:58:38 +0100

debian-installer (20101020ubuntu126) precise; urgency=low

  * Move armel/omap4 and armhf/omap4 to 3.2.0-1411.

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 27 Mar 2012 15:04:37 -0600

debian-installer (20101020ubuntu125) precise; urgency=low

  * No-change rebuild to pick up new libcrypto1.0.0-udeb.

 -- Colin Watson <cjwatson@ubuntu.com>  Sun, 25 Mar 2012 15:04:23 +0100

debian-installer (20101020ubuntu124) precise; urgency=low

  * Bump amd64, i386, and powerpc netboot image sizes by a megabyte to
    accommodate nic-firmware growth.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 22 Mar 2012 12:06:46 +0000

debian-installer (20101020ubuntu123) precise; urgency=low

  * Move armel/omap4 and armhf/omap4 to 3.2.0-1410.
  * Move generic distro kernels to 3.2.0-20.

 -- Adam Conrad <adconrad@ubuntu.com>  Thu, 22 Mar 2012 03:42:02 -0600

debian-installer (20101020ubuntu122) precise; urgency=low

  * Switch PPC32 builds to the powerpc-smp kernel.

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 20 Mar 2012 09:55:41 -0600

debian-installer (20101020ubuntu121) precise; urgency=low

  * Move armhf/armadaxp to 3.2.0-1600, not 3.0.0-1600.
  * Move generic distro kernels to 3.2.0-19.
  * Move armel/omap4 and armhf/omap4 to 3.2.0-1409.

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 18 Mar 2012 11:34:42 -0600

debian-installer (20101020ubuntu120) precise; urgency=low

  * Move armadaxp to 3.2.0-1600 kernel.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Sat, 17 Mar 2012 11:14:13 +0100

debian-installer (20101020ubuntu119) precise; urgency=low

  * Add a new cdrom/isolinux/non-pae build for i386 that uses the -generic
    kernel flavour (LP: #955009).

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 15 Mar 2012 18:41:47 +0000

debian-installer (20101020ubuntu118) precise; urgency=low

  * Move armel/omap4 and armhf/omap4 to 3.2.0-1408 kernels.
  * Update help text translations from Launchpad.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 14 Mar 2012 09:19:58 +0000

debian-installer (20101020ubuntu117) precise; urgency=low

  * Move to 3.2.0-18 kernels.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Sat, 03 Mar 2012 16:50:49 +0100

debian-installer (20101020ubuntu116) precise; urgency=low

  * Move armel/omap4 and armhf/omap4 to 3.2.0-1407 kernels.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Fri, 02 Mar 2012 19:07:54 +0100

debian-installer (20101020ubuntu115) precise; urgency=high

  * Correct mkimage arguments to generate a working uImage for ArmadaXP

 -- Michael Casadevall <mcasadevall@ubuntu.com>  Mon, 27 Feb 2012 03:41:37 -0800

debian-installer (20101020ubuntu114) precise; urgency=low

  * Rebuild against new netcfg 1.68ubuntu12 (resolvconf fixes).

 -- Stéphane Graber <stgraber@ubuntu.com>  Thu, 23 Feb 2012 18:14:14 -0500

debian-installer (20101020ubuntu113) precise; urgency=low

  * Correct pathing error in armadaxp dest folder

 -- Michael Casadevall <mcasadevall@ubuntu.com>  Thu, 23 Feb 2012 01:30:12 -0800

debian-installer (20101020ubuntu112) precise; urgency=low

  * Added armadaxp images (LP: #934451)

 -- Michael Casadevall <mcasadevall@ubuntu.com>  Wed, 22 Feb 2012 23:38:35 -0800

debian-installer (20101020ubuntu111) precise; urgency=low

  * Move to 3.2.0-17 kernels.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 21 Feb 2012 09:40:57 +0100

debian-installer (20101020ubuntu110) precise; urgency=low

  * Move armel/omap4 and armhf/omap4 to 3.2.0-1406 kernels.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 15 Feb 2012 11:11:31 +0100

debian-installer (20101020ubuntu109) precise; urgency=low

  * Move to 3.2.0-16 kernels.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 14 Feb 2012 19:24:50 +0100

debian-installer (20101020ubuntu108) precise; urgency=low



=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Vcs-Bzr: http://bazaar.launchpad.net/~ubuntu-core-dev/debian-installer/ubuntu
 Build-Conflicts: libnewt-pic [mipsel]
 # NOTE: Do not edit the next line by hand. See comment below.
-Build-Depends: debhelper (>= 7.0.0), apt, apt-utils, gnupg, ubuntu-keyring, dctrl-tools, wget, bc, debiandoc-sgml, xsltproc, docbook-xml, docbook-xsl, libbogl-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], lsb-release, glibc-pic, libslang2-pic (>= 2.0.6-4), libnewt-pic (>= 0.52.2-11.3) [!mipsel], libnewt-dev (>= 0.52.2-11.3) [mipsel], libgcc1 [i386 amd64], cramfsprogs [powerpc ia64 mips mipsel armeb armel], genext2fs (>= 1.3-7.1), e2fsprogs, mklibs (>= 0.1.25), genisoimage (>= 9:1.1.10-1ubuntu2) [!s390 !s390x], genromfs [sparc sparc64], hfsutils [powerpc], dosfstools (>= 3.0.9-1ubuntu2) [i386 ia64 m68k amd64 armel], cpio, devio [armeb armel], parted [armel], slugimage (>= 0.10+r58-6) [armeb armel], u-boot-tools [armel], syslinux (>= 2:4.02) [i386 amd64], palo [hppa], elilo [ia64], yaboot [powerpc], aboot (>= 0.9b-2) [alpha], silo [sparc], sparc-utils [sparc sparc64], genisovh [mips], tip22 [mips], colo [mipsel], sibyl [mips mipsel], atari-bootstrap [m68k], vmelilo [m68k], m68k-vme-tftplilo [m68k], amiboot [m68k], emile [m68k], emile-bootblocks [m68k], x-loader-omap3-beagle [armel], u-boot-linaro-omap3-beagle [armel], u-boot-linaro-omap4-panda [armel], tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64], mtools [i386 ia64 m68k amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 armel], po4a [i386 amd64], python [i386 amd64], module-init-tools [i386 armeb armel amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sh4 sparc sparc64], bf-utf-source [!s390 !s390x], mkvmlinuz [powerpc], openssl [armel], makefs [kfreebsd-i386 kfreebsd-amd64], grub-pc (>= 1.98~20100101-1) [kfreebsd-i386 kfreebsd-amd64 hurd-i386], xorriso [kfreebsd-i386 kfreebsd-amd64 hurd-i386], grub-efi-amd64-bin [amd64], grub-common [amd64], debian-ports-archive-keyring [sh4 sparc64]
+Build-Depends: debhelper (>= 7.0.0), apt, apt-utils, gnupg, ubuntu-keyring, dctrl-tools, wget, bc, debiandoc-sgml, xsltproc, docbook-xml, docbook-xsl, libbogl-dev [!kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], lsb-release, glibc-pic, libslang2-pic (>= 2.0.6-4), libnewt-pic (>= 0.52.2-11.3) [!mipsel], libnewt-dev (>= 0.52.2-11.3) [mipsel], libgcc1 [i386 amd64], cramfsprogs [powerpc ia64 mips mipsel armeb armel], genext2fs (>= 1.3-7.1), e2fsprogs, mklibs (>= 0.1.25), genisoimage (>= 9:1.1.10-1ubuntu2) [!s390 !s390x], genromfs [sparc sparc64], hfsutils [powerpc], dosfstools (>= 3.0.9-1ubuntu2) [i386 ia64 m68k amd64 armel armhf], cpio, devio [armeb armel], parted [armel armhf], slugimage (>= 0.10+r58-6) [armeb armel], u-boot-tools [armel armhf], syslinux (>= 2:4.02) [i386 amd64], palo [hppa], elilo [ia64], yaboot [powerpc], aboot (>= 0.9b-2) [alpha], silo [sparc], sparc-utils [sparc sparc64], genisovh [mips], tip22 [mips], colo [mipsel], sibyl [mips mipsel], atari-bootstrap [m68k], vmelilo [m68k], m68k-vme-tftplilo [m68k], amiboot [m68k], emile [m68k], emile-bootblocks [m68k], u-boot-linaro-omap3-beagle [armel armhf], u-boot-linaro-omap4-panda [armel armhf], tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64], mtools [i386 ia64 m68k amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 armel armhf], po4a [i386 amd64], python [i386 amd64], module-init-tools [i386 armeb armel armhf amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sh4 sparc sparc64], bf-utf-source [!s390 !s390x], mkvmlinuz [powerpc], openssl [armel], makefs [kfreebsd-i386 kfreebsd-amd64], grub-pc (>= 1.98~20100101-1) [kfreebsd-i386 kfreebsd-amd64 hurd-i386], xorriso [kfreebsd-i386 kfreebsd-amd64 hurd-i386], grub-efi-amd64-bin [amd64], grub-common [amd64], debian-ports-archive-keyring [sh4 sparc64]
 # This package has the worst Build-Depends in Debian, so it deserves some
 # explanation. Note that this comment can also be used to generate a
 # Build-Depends line, by running the debian/genbuilddeps program.
@@ -82,23 +82,23 @@
 #		default.)
 #	- hfsutils [powerpc]
 #		For making bootable HFS USB sticks for powerpc.
-#	- dosfstools (>= 3.0.9-1ubuntu2) [i386 ia64 m68k amd64 armel]
+#	- dosfstools (>= 3.0.9-1ubuntu2) [i386 ia64 m68k amd64 armel armhf]
 #		For creating FAT filesystems with mkfs.msdos.
 #		Of course i386/amd64 use this for floppies, CDs etc.
 #		ia64 uses it for floppies (?)
 #		m68k uses it for atari floppies
-#		armel uses it for omap3/4 netboot images and requires
+#		armel/armhf uses it for omap3/4 netboot images and requires
 #		3.0.9-1ubuntu2 to create bootable filesystems on OMAP
 #	- cpio
 #		For creating initramfs images.
 #	- devio [armeb armel]
 #		Tool to read and write from block devices, used to byteswap
 #		kernels and add nslu2 boot magic.
-#	- parted [armel]
+#	- parted [armel armhf]
 #		For ARM OMAP images.
 #	- slugimage (>= 0.10+r58-6) [armeb armel]
 #		For building nslu2 firmware images.
-#	- u-boot-tools [armel]
+#	- u-boot-tools [armel armhf]
 #		For creating u-boot images
 #
 # Boot loaders:
@@ -139,23 +139,22 @@
 #	- emile [m68k]
 #	- emile-bootblocks [m68k]
 #		Bootloader for m68k/mac machines.
-#	- x-loader-omap3-beagle [armel]
-#	- u-boot-linaro-omap3-beagle [armel]
-#	- u-boot-linaro-omap4-panda [armel]
+#	- u-boot-linaro-omap3-beagle [armel armhf]
+#	- u-boot-linaro-omap4-panda [armel armhf]
 #		First and second state bootloaders for omap 3/4
 #
 # Architecture specific build dependencies:
 #	- tofrodos [i386 amd64 kfreebsd-i386 kfreebsd-amd64]
 #		For todos, used on files that need to be accessible from
 #		DOS.
-#	- mtools [i386 ia64 m68k amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 armel]
+#	- mtools [i386 ia64 m68k amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 armel armhf]
 #		mcopy is used to put files onto FAT filesystems w/o
 #		mounting them.
 #	- po4a [i386 amd64]
 #	- python [i386 amd64]
 #		For building gfxboot help texts.
 #
-#	- module-init-tools [i386 armeb armel amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sh4 sparc sparc64]
+#	- module-init-tools [i386 armeb armel armhf amd64 alpha hppa ia64 m68k mips mipsel powerpc s390 sh4 sparc sparc64]
 #		depmod for 2.6 kernels on the arches that support 2.6.
 #
 #	- bf-utf-source [!s390 !s390x]

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 DATE=$(shell echo $(VERSION) | cut -d '.' -f 1)
 SUITE=$(shell LC_ALL=C dpkg-parsechangelog | grep ^Distribution: | cut -d ' ' -f 2 | cut -d - -f 1)
 ifeq (${SUITE},UNRELEASED)
-USE_UDEBS_FROM=oneiric
+USE_UDEBS_FROM=precise
 TRANSSTATUS=
 BOOTMENU_BEEP=n
 else
